/*
About this program:
This program is used to convolve two signals input from the console
by the user or raed from two files name which can be input from the user.
The maximum length of the siganls is limited to 25 but it can be increased
easily  by incresing the memory allocated to store the samples of the
signals to be convolved and the convolved output.
The program also asks the user to input the starting point for the two input
signals and pads adequate number of zeros if starting point is greter then
the length of the signal.
The program starts the convolution from appropriate point according to the
starting points for the two signals.
The output is stored in the default output file, Conv.txt, which can be
viewed using the SHOW utility.
*/
#include<stdio.h>
#include<conio.h>
#include<dos.h>
/*
FileTag is the specific string used to identify the file generated
using this program.
*/
#define FileTag "NGPFile&"
int i,j,Hlen,Xlen,Choice,Count,hStrptr,xStrptr;
float Signalh[50],Signalx[50],ConOut[50],Sum;
float MaxY,MinY;
char flnameh[20],flnamex[20];
void ReadSig();
void ReadFileSig();
void DispSamples();
main()
{

  FILE *out;

        /*Leave----------------------------*/
        clrscr();
        for(j = 0;j < 80;j++)
		printf("");
	printf("\t\t\t\t Convolution. \n");
        for(j = 0;j < 80;j++)
		printf("");
        /*---------------------------------*/

	printf("\nWhat is the format of Input?"
	       "\n1. File."
	       "\n2. Console"
	       "\nInput Your Choice: ");
	scanf("%d",&Choice);

        /*
        set the input and output arrays to zero.
        */
        for(i= 0; i<50; i++)
	{
		Signalh[i] = 0;
		Signalx[i] = 0;
		ConOut[i] = 0;
	}
        /*
        choice used to decide wheather to read the signal from the file
        or from the console.
        */
	switch(Choice)
	{
	  case 1:
		fflush(stdin);
		printf("\nInput the name of H signal file: ");
		scanf("%s",flnameh);
		printf("\nInput the name of X signal file: ");
		scanf("%s",flnamex);
		ReadFileSig();
		break;
	  case 2:
		ReadSig();
		break;
	  Default:
		printf("Invalid Choice !! \nPress any key to Continue.");
		getch();
		ReadSig();
	}
        /*Leave-------------------------*/
	clrscr();
        for(j = 0;j < 80;j++)
		printf("");
	printf("\t\t\t\t Convolution. \n");
        for(j = 0;j < 80;j++)
		printf("");
        /*------------------------------*/

        /*
        Get the starting point for the signal H.
        */
        printf("\nInput the starting point for the H signal: ");
	scanf("%d",&hStrptr);

        /*
        Pad zeros. This is done automatically since will have set the
        all arrays to zero initially.
        */
	if(hStrptr >= Hlen)
	{
		Hlen = hStrptr + 1;
                printf("This will pad zero's to the signal.");
	}
        /*
        Exit if length of siganl exceeds 25.
        */
	if(Hlen > 25)
	{
		printf("\nLength of signal can't be greater than 25.");
		getch();
		exit(0);
	}

        /*
        Get the starting point for the signal X.
        */
	printf("\n\nInput the starting point for the X signal: ");
	scanf("%d",&xStrptr);
        /*
        Pad zeros. This is done automatically since will have set the
        all arrays to zero initially.
        */
	if(xStrptr >= Xlen)
	{
		Xlen = xStrptr + 1;
		printf("This will pad zero's to the signal.");
	}

        /*
        Exit if length of siganl exceeds 25.
        */
        if(Xlen > 25)
	{
		printf("\nLength of signal can't be greater than 25.");
		getch();
		exit(0);
	}
        /*
        Get the way in which the output will be repesented.
        reder needn't go through this.
        */
	printf("\n\nWhich way you want to perform Convolution?"
	       "\n1. Single Stepping."
	       "\n2. Auto Stepping."
	       "\n3. Direct.");
	printf("\nInput Your Choice: ");
	scanf("%d",&Choice);

        /*****************************************************************
        CORE LOOP OF THE CONVOLUTION STARTS HERE.
        *****************************************************************/
	Count = 1;

        for(i= 0;i < Xlen + Hlen -1; i++)
        /*
        Length of convolved output = length of H signal + length of X signal -1.
        */
	{

		Sum = 0;
                /*
                Perform
                 X(k) * H(n-k)
                where,
                k => j
                n => i => Count
                Count - j - 1 => array in 'C' strats from 0.
                */
		for (j = 0; j < Count; j++)
		{
			Sum = Sum + Signalh[Count - j - 1] * Signalx[j];
		}
		ConOut[i] = Sum;

                /*
                User needn't go though the code for function DispSamples
                it is used to display the samples on the screen.
                and perform autostepping / single stepping as is the
                input from the user.
                */
		DispSamples();

		Count++;
	}
        /*****************************************************************
        END OF CONVOLUTION.
        ******************************************************************/

        /*
        Find the maximum and minimum of the output array.
        */

        MaxY = ConOut[0];
        MinY = ConOut[0];

	for(i = 0; i< Xlen + Hlen - 1; i++)
	{
                if(MaxY < ConOut[i])
                        MaxY = ConOut[i];
                if(MinY > ConOut[i])
                        MinY = ConOut[i];

	}
	if(MinY > 0)
		MinY = 0;
        /*Leave-----------------------------------*/
        clrscr();
	for(j = 0;j < 80;j++)
		printf("");
	printf("\t\t\t\t Convolution. \n");
	for(j = 0;j < 80;j++)
		printf("");
        /*----------------------------------------*/

	printf("\nThe signals are:\n(Read H signal   X Signal   Output)");

        /*
        Open the file for the writing output of the convolution.
        */
        out = fopen("Conv.txt","w");
        if(out == NULL)
	{
                printf("Can't open file: Conv.txt \n");
		exit(1);
	}
        /*
        Write the required file format.
        Refer to generate.c
        */
        fprintf(out,FileTag);
	fprintf(out,"\n3");
	fprintf(out,"\n5");
        fprintf(out,"\n%d" ,(Xlen + Hlen - 1));
        fprintf(out,"\n%f",MaxY);
        fprintf(out,"\n%f",MinY);
        fprintf(out,"\nSamples");
        fprintf(out,"\nAmpl.");

        /*
        Write the input signals and the convolved output to the screen as well
        as to the file conv.txt
        */
	for(i = 0; i< Xlen + Hlen - 1; i++)
	{

		printf("\n h[%d] = %f",i - hStrptr,Signalh[i]);
		fprintf(out,"\n %f",Signalh[i]);

		printf("\t x[%d] = %f",i - xStrptr,Signalx[i]);
		fprintf(out,"\t%f",Signalx[i]);

		printf("\t out[%d] = %f",i - xStrptr - hStrptr,ConOut[i]);
		fprintf(out,"\t%f",ConOut[i]);

		if(i % 20 == 0 && i != 0)
		{
			getch();
			clrscr();
		}
	}
        rewind(out);
        fclose(out);
	getch();
	clrscr();
}
/*
This function used to display input samples and the convolved output.
*/
void DispSamples()
{
   int m;

   if(Choice < 1 || Choice > 2 )
	return;
   clrscr();

   for(j = 0;j < 80;j++)
		printf("");
	printf("\t\t\t\t Convolution. \n");
	for(j = 0;j < 80;j++)
		printf("");
   printf("\nShifting..");
   printf("\n\nH Signal:\n");
   /*
   Print the first 10 samples of H signal.
   */
   for(m = 0; m< 10; m++)
   {
	printf(" %0.2f",Signalh[m]);
   }

   /*
   Print the current 10 samples of X signal.
   */
   printf("\n\nX Signal:\n");
   for(m = 0; m< 10; m++)
   {
	if(Count - m > 0)
		printf(" %0.2f",Signalx[Count - m - 1]);
	else
		printf(" 0.00");
   }
   /*
   Display the output signal.
   */
   printf("\n\n\nDoing Calculations:  h(k) x(n-k) ...");
   printf("\n\nOutput signal: \n");
   for(m = 0; m< 10; m++)
   {
		printf(" %0.2f",ConOut[m]);
   }
   /*
   If single stepping wait for key to be pressed else provide delay bet
   output.
   */
   switch(Choice)
   {
      case 2:
        delay(5000);
	break;
      case 1:
	fflush(stdin);
	printf("\n\n\nPress Any key to continue.");
	getch();
   }
   return;
}
/*
This function is used to read H signal and X signal from the console.
*/
void ReadSig()
{
        /*Leave-----------------------------*/
        clrscr();
        for(j = 0;j < 80;j++)
		printf("");
	printf("\t\t\t\t Convolution. \n");
        for(j = 0;j < 80;j++)
		printf("");
        /*---------------------------------*/
        /*
        Get length of H signal.
        */
	printf("Input The length of H signal(<25):");
	scanf("%d",&Hlen);
        /*
        Exit if length of H signal is > 25.
        */
	if(Hlen > 25)
	{
		printf("Length of signal can't be greater than 25.");
		getch();
		exit(0);
	}

        /*
        Get length of X signal.
        */

	printf("Input The length of X signal(<25): ");
	scanf("%d",&Xlen);

        /*
        Exit if length of X signal is > 25.
        */
	if(Xlen > 25)
	{
		printf("Length of signal can't be greater than 25.");
		getch();
		exit(0);
	}

        /*Leave-----------------------------*/
	clrscr();
        for(j = 0;j < 80;j++)
		printf("");
	printf("\t\t\t\t Convolution. \n");
        for(j = 0;j < 80;j++)
		printf("");
        /*----------------------------------*/
        /*
        Read H signal.
        */
	fflush(stdin);
	printf("Input the H signal Samples: \n");
	for(i=0; i< Hlen; i++)
	{
		scanf("%f",&Signalh[i]);
	}

        /*Leave-----------------------------*/
        clrscr();
        for(j = 0;j < 80;j++)
		printf("");
	printf("\t\t\t\t Convolution. \n");
        for(j = 0;j < 80;j++)
		printf("");
        /*----------------------------------*/

        /*
        Read X signal.
        */
	fflush(stdin);
	printf("Input the X signal Samples: \n");
	for(i=0; i< Xlen; i++)
	{
		scanf("%f",&Signalx[i]);
	}
}
/*
This function is used to Read H and X signal from the files.
It is same as the ReadSig function above only difference
is that the signal are read from the file.
*/
void ReadFileSig()
{
  int SampleCount,Override;
  int YsampleNo, Yinputs;
  char CompareTag[20],Xtag[20],Ytag[20];
  FILE *sigh,*sigx;

        sigh = fopen(flnameh,"r");
        if(sigh == NULL)
	{
                printf("Can't open file: %s \n",flnameh);
		exit(1);
	}
        /*
        Read the file Tag.
        */
        fscanf(sigh,"%s",CompareTag);
	if(strlen(CompareTag) != 12 || strcmp(CompareTag,FileTag) != 0)
	{
		printf("Invalid Tag in file: %s \n",flnameh);
                exit(2);
	}
        if(feof(sigh))
	{
		printf("Invalid File Format. \n");
		exit(3);
	}

        /*
        Read the No. of signals in the file.
        */
        fscanf(sigh,"%d",&Yinputs);
        if(feof(sigh) || Yinputs != 1)
	{
                if(Yinputs != 1)
                        printf("Can't take two inputs from single file.\n");
                else
                        printf("Invalid File Format. \n");
		exit(4);
	}

        /*
        Read the pixel distance on x axis between the samples.
        */
        fscanf(sigh,"%d",&Override);
	if(feof(sigh))
	{
		printf("Invalid File Format. \n");
		exit(5);
	}
        /*
        Raed the number of samples.
        */
        fscanf(sigh,"%d",&YsampleNo);
        if(feof(sigh) || YsampleNo < 1)
	{
		printf("Invalid File Format. \n");
		exit(5);
	}

        /*
        Trucate the signal to required length.
        */
	if(YsampleNo > 25)
		YsampleNo = 25;

        /*
        Read the Maximum and Minimum values.
        */

        fscanf(sigh,"%f",&MaxY);
	if(feof(sigh) || MaxY > 1.0e+5)
	{
		printf("Invalid File Format. \n");
		exit(5);
	}
        fscanf(sigh,"%f",&MinY);
	if(feof(sigh) || MinY < -1.0e5)
	{
		printf("Invalid File Format. \n");
		exit(6);
	}
        fscanf(sigh,"%s",Xtag);
        if(feof(sigh))
	{
		printf("Invalid File Format. \n");
		exit(7);
	}
        fscanf(sigh,"%s",Ytag);
        if(feof(sigh))
	{
		printf("Invalid File Format. \n");
		exit(8);
	}
        /*
        Read the samples from the file.
        */
	SampleCount = 0;
        while(!feof(sigh))
	{
             if(feof(sigh))
		break;
             fscanf(sigh,"%f",&Signalh[SampleCount]);

	     SampleCount++;
	     if(SampleCount > 24)
		break;
	}

        if(SampleCount < YsampleNo - 1)
	{
           printf("Invalid File Format. \n");
           exit(9);
	}

        /*
        Length of the H signal.
        */

	Hlen = SampleCount;
        rewind(sigh);
        fclose(sigh);


/*-----------------------------------------------------------------------*/
/*
Repeat the above procedure for reading the samples from the file for
X signal, and get the X signal samples and it's length.
*/

        sigx = fopen(flnamex,"r");
        if(sigx == NULL)
	{
                printf("Can't open file: %s \n",flnamex);
		exit(1);
	}
        fscanf(sigx,"%s",CompareTag);
	if(strlen(CompareTag) != 12)
	{
		printf("Invalid Tag in file: %s \n",flnamex);
                exit(2);
	}
        if(feof(sigx))
	{
		printf("Invalid File Format. \n");
		exit(3);
	}
        fscanf(sigx,"%d",&Yinputs);
        if(feof(sigx) || Yinputs != 1)
	{
                if(Yinputs != 1)
                        printf("Can't take two inputs from single file.\n");
                else
                        printf("Invalid File Format. \n");
                exit(4);
	}
	fscanf(sigx,"%d",&Override);
	if(feof(sigx))
	{
		printf("Invalid File Format. \n");
		exit(5);
	}
        fscanf(sigx,"%d",&YsampleNo);
        if(feof(sigx) || YsampleNo < 1)
	{
		printf("Invalid File Format. \n");
		exit(5);
	}
	if(YsampleNo > 25)
		YsampleNo = 25;

        fscanf(sigx,"%f",&MaxY);
        if(feof(sigx) || MaxY > 1.0e+5)
	{
		printf("Invalid File Format. \n");
		exit(5);
	}
        fscanf(sigx,"%f",&MinY);
        if(feof(sigx) || MinY < -1.0e5)
	{
		printf("Invalid File Format. \n");
		exit(6);
	}
        fscanf(sigx,"%s",Xtag);
        if(feof(sigx))
	{
		printf("Invalid File Format. \n");
		exit(7);
	}
        fscanf(sigx,"%s",Ytag);
        if(feof(sigx))
	{
		printf("Invalid File Format. \n");
		exit(8);
	}
	SampleCount = 0;
        while(!feof(sigx))
	{
             if(feof(sigx))
		break;
	     fscanf(sigx,"%f",&Signalx[SampleCount]);
	     SampleCount++;
	     if(SampleCount > 24)
		break;
	}
	if(SampleCount < YsampleNo - 1)
	{
           printf("Invalid File Format. \n");
	   exit(9);
	}
        Xlen = SampleCount;
        rewind(sigx);
        fclose(sigx);

}
