/*
About this program:
This program is used to calculate the output of a system, which is
described by the linear difference equation,
y(n) = a0 * x(n) + a1 * x(n-1) + a2 * x(n-2) + .... + aP * x(n-P)
        + b1 * y(n-1) + b2 * y(n-2) + .... + bQ * y(n-Q)
where y(n) and x(n) represent current output and input respectively.
The user has to input the a coefficients and the y coefficients.
The input siganl to the system can be from the file or from the console.
The output is written to the file DiffEq.txt which can be seen using the
utility SHOW.
*/
#include<stdio.h>
#include<conio.h>
#include<dos.h>

/*
FileTag is the specific string used to identify the file generated
using this program.
*/
#define FileTag "NGPFile&"
int i,j,Xlen,Choice,Count,Xnum,Ynum;
float Signal[500],ConOut[500],Sum,Ycoeff[20],Xcoeff[20];
float MaxY,MinY;
char flnames[20];
void ReadSig();
void ReadFileSig();
main()
{

  FILE *out;

	clrscr();

        /*
        Set all inputs and output to zero.
        */
        for(i= 0;i<20;i++)
        {
                Xcoeff[i] = 0;
                Ycoeff[i] = 0;
        }
        for(i= 0; i<500; i++)
	{
                Signal[i] = 0;
		ConOut[i] = 0;
	}

        /*Leave---------------------------------------------------*/
        for(j = 0;j < 80;j++)
		printf("");
	printf("\t\t Difference Equation Based Array Mapping.\n");
        for(j = 0;j < 80;j++)
		printf("");
        /*--------------------------------------------------------*/

        /*
        Get the number of a coefficients and b coefficients.
        */
        printf("Input The No. of X coefficients (< 20): ");
        scanf("%d",&Xnum);
	printf("Input The No. of Y coefficients (< 20): ");
	scanf("%d",&Ynum);

        /*
        Read a and b coefficients.
        */
        fflush(stdin);
	if(Xnum > 0)
	{
		printf("\nInput the X coefficients: \n");
		for(i=0; i< Xnum; i++)
		{
			scanf("%f",&Xcoeff[i]);
		}
	}

	fflush(stdin);
	if(Ynum > 0)
	{
		printf("\nInput the Y coefficients: \n");
		for(i=0; i< Xnum; i++)
		{
			scanf("%f",&Ycoeff[i]);
		}
	}
        /*Leave---------------------------------------------------*/
	clrscr();
        for(j = 0;j < 80;j++)
		printf("");
	printf("\t\t Difference Eqation Based Array Mapping. \n");
	for(j = 0;j < 80;j++)
		printf("");
        /*--------------------------------------------------------*/

        printf("\nWhat is the format of Input Signal?"
	       "\n1. File."
	       "\n2. Console"
	       "\nInput Your Choice: ");
	scanf("%d",&Choice);

        /*
        Read the input signal from the file or from the console.
        */
	switch(Choice)
	{
	  case 1:
		fflush(stdin);
                printf("\nInput the name of Signal file: ");
                scanf("%s",flnames);
		ReadFileSig();
		break;
	  case 2:
		ReadSig();
		break;
	  Default:
		printf("Invalid Choice !! \nPress any key to Continue.");
		getch();
		ReadSig();
	}

        /*
        Perform the operation,
        y(n) = a0 * x(n) + a1 * x(n-1) + a2 * x(n-2) + .... + aP * x(n-P)
                + b1 * y(n-1) + b2 * y(n-2) + .... + bQ * y(n-Q)
        for complete length of the input signal.
        */
        for(i= 0;i < Xlen; i++)
	{

		Sum = 0;
                for (j = 0; j < Xnum; j++)
		{
                        if(i - j >= 0)
                        Sum = Sum + Signal[i - j] * Xcoeff[j];
		}

                for(j = 0; j< Ynum; j++)
                {
                        if(i - j > 0)
                        Sum = Sum + ConOut[i - j - 1] * Ycoeff[j];
                }
                ConOut[i] = Sum;
	}
        /*
        Calculate the maximum and minimum out of the input and  output
        signal.
        */
        MaxY = ConOut[0];
        MinY = ConOut[0];

        for(i = 0; i< Xlen; i++)
	{
		if(MaxY < Signal[i])
			MaxY = ConOut[i];
                if(MaxY < ConOut[i])
			MaxY = ConOut[i];
		if(MinY > Signal[i])
			MinY = ConOut[i];
                if(MinY > ConOut[i])
			MinY = ConOut[i];

	}
        if(MinY > 0 && MinY < 50)
		MinY = 0;
        /*Leave--------------------------------------------------*/
	clrscr();
	for(j = 0;j < 80;j++)
		printf("");
	printf("\t\t Difference Equation Based Array Mapping. \n");
	for(j = 0;j < 80;j++)
		printf("");
        /*-----------------------------------------------------*/

        /*
        Print the input and output signals to the console as well as the file
        Diffeq.txt
        */
        printf("\nThe signals are:\n(Read Input signal   Output Signal)");
        out = fopen("DiffEq.txt","w");
        if(out == NULL)
	{
                printf("Can't open file: Conv.txt \n");
		exit(1);
	}
        /*
        Write the file format.
        */
        fprintf(out,FileTag);
        fprintf(out,"\n2");
        if(Choice == 1)
                fprintf(out,"\n1");
        else
                fprintf(out,"\n5");

        fprintf(out,"\n%d" ,Xlen);
        fprintf(out,"\n%f",MaxY);
        fprintf(out,"\n%f",MinY);
        fprintf(out,"\nSamples");
        fprintf(out,"\nAmpl.");

        /*
        Display the input and output samples.
        */

        for(i = 0; i< Xlen; i++)
	{
                printf("\n %f",Signal[i]);
                fprintf(out,"\n %f",Signal[i]);

                printf("\t%f",ConOut[i]);
		fprintf(out,"\t%f",ConOut[i]);
		if(i % 20 == 0 && i != 0)
		{
			getch();
			clrscr();
		}
	}
        rewind(out);
        fclose(out);
	getch();
	clrscr();
}
/*
This function is used to read the samples of the signal from the console.
Refer to Convolve.c  for explaination.
*/
void ReadSig()
{
	clrscr();
        for(j = 0;j < 80;j++)
		printf("");
        printf("\t\t\t\t Difference Equation Based Array Mapping.\n");
        for(j = 0;j < 80;j++)
		printf("");
	printf("Input The length of the signal: ");
	scanf("%d",&Xlen);
	clrscr();
        for(j = 0;j < 80;j++)
		printf("");
	printf("\t Difference Eqation Based Array Mapping. \n");
        for(j = 0;j < 80;j++)
		printf("");
	fflush(stdin);
	printf("Input the signal Samples: \n");
	for(i=0; i< Xlen; i++)
	{
		scanf("%f",&Signal[i]);
	}
        clrscr();
}

/*
This function is used to read the samples of the signal from the file.
Refer to Convolve.c  for explaination.
*/
void ReadFileSig()
{
  int SampleCount,Override;
  int YsampleNo, Yinputs;
  char CompareTag[20],Xtag[20],Ytag[20];
  FILE *input;

	input = fopen(flnames,"r");
        if(input == NULL)
	{
		printf("Can't open file: %s \n",flnames);
		exit(1);
	}
        fscanf(input,"%s",CompareTag);
	if(strlen(CompareTag) != 12 || strcmp(CompareTag,FileTag) != 0)
	{
		printf("Invalid Tag in file: %s \n",flnames);
                exit(2);
	}
        if(feof(input))
	{
		printf("Invalid File Format. \n");
		exit(3);
	}
        fscanf(input,"%d",&Yinputs);
        if(feof(input) || Yinputs != 1)
	{
                if(Yinputs != 1)
                        printf("Can't take more than one input from single file.\n");
                else
                        printf("Invalid File Format. \n");
		exit(4);
	}
	fscanf(input,"%d",&Override);
	if(feof(input))
	{
		printf("Invalid File Format. \n");
		exit(5);
	}
        fscanf(input,"%d",&YsampleNo);
        if(feof(input) || YsampleNo < 1)
	{
		printf("Invalid File Format. \n");
		exit(5);
	}
	if(YsampleNo > 500)
		YsampleNo = 500;

        fscanf(input,"%f",&MaxY);
        if(feof(input) || MaxY > 1.0e+5)
	{
		printf("Invalid File Format. \n");
		exit(5);
	}
        fscanf(input,"%f",&MinY);
        if(feof(input) || MinY < -1.0e5)
	{
		printf("Invalid File Format. \n");
		exit(6);
	}
        fscanf(input,"%s",Xtag);
        if(feof(input))
	{
		printf("Invalid File Format. \n");
		exit(7);
	}
        fscanf(input,"%s",Ytag);
        if(feof(input))
	{
		printf("Invalid File Format. \n");
		exit(8);
	}
	SampleCount = 0;
        while(!feof(input))
	{
             if(feof(input))
		break;
	     fscanf(input,"%f",&Signal[SampleCount]);

	     SampleCount++;
	     if(SampleCount > 499)
		break;
	}
	if(SampleCount < YsampleNo - 1)
	{
           printf("Invalid File Format. \n");
	   exit(9);
	}
	Xlen = SampleCount;
        rewind(input);
        fclose(input);

}
