/*
About this program:
This program is used to calculate the fourier transform of the signal at
a particular frequency input by the user.
The formula used is,
        X(w) =   x(n) * e^(-j*w*n)
The value of w varies from 0 to Pi, and is input from the user.
Teh signal of which the fourier transform is calculated can be input
from the console or the file.
*/
#include<stdio.h>
#include<conio.h>
#include<dos.h>
#include<math.h>
#define FileTag "NGPFile&"
int i,j,Xlen,Choice,Count;
float Signal[500],Sum;
float MaxY,MinY;
char flnames[20];
void ReadSig();
void ReadFileSig();
main()
{

	int N,k,num;
	float Sampfreq,freq,Nyquist,RealComp,ImgComp;
	float FtRealComp,FtImgComp;
	double Theta,Pi;

        /*
        Define the value of Pi.
        */
        Pi = 22.0/7.0;
        clrscr();
        /*
        Set the input to zero.
        */
        for(i= 0; i<500; i++)
	{
                Signal[i] = 0;
	}
        /*Leave----------------------------------*/
        for(j = 0;j < 80;j++)
		printf("");
        printf("\t\t\t Fourier Transform.\n");
        for(j = 0;j < 80;j++)
		printf("");
        /*---------------------------------------*/

        /*
        Get the sampling frq. and the frqency at which the fourier transform
        is to be calculated.
        */
        printf("Input the Sampling frequency: ");
                scanf("%f",&Sampfreq);

	printf("Input the frequency at which the Fourier Transform of\n"
	       "the given sequence is to be calculated: ");
	scanf("%f",&freq);

        /*
        Check the Nyquist criterian.
        */
        Nyquist = Sampfreq / freq;

	if(Nyquist < 2.0)
	{
		printf("\n**** ERROR ****"
		"\nAccording to the Nyquist Criterian"
		" Sampling frequency should be at least \n"
		"twice the waveform frequency.\n");
		for(j = 0;j < 80;j++)
			printf("");
		printf("\nExiting...");
		exit(1);
	}

	printf("\nWhat is the format of Input Signal?"
	       "\n1. File."
	       "\n2. Console"
	       "\nInput Your Choice: ");
	scanf("%d",&Choice);

        /*
        Get the samples of the signal.
        */
	switch(Choice)
	{
	  case 1:
		fflush(stdin);
                printf("\nInput the name of Signal file: ");
                scanf("%s",flnames);
		ReadFileSig();
		break;
	  case 2:
		ReadSig();
		break;
	  Default:
		printf("Invalid Choice !! \nPress any key to Continue.");
		getch();
		ReadSig();
	}

        /*Leave-----------------------------------*/
        clrscr();
        for(j = 0;j < 80;j++)
		printf("");
        printf("\t\t\t Fourier Transform. \n");
	for(j = 0;j < 80;j++)
		printf("");
        /*----------------------------------------*/

	N = Xlen;
	printf("\nThe Fourier transform of the sequence at a particular frequency\n"
	       "is given by,\n         X(w) =   x(n) * e^(-j*w*n) \n"
	       "and n = 0 to %d.\n",N);
        /*
        Calculate w.
        */
	Theta = freq * 2 * Pi/ Sampfreq;

        /*
        Calculate Fourier Transform for sequence length 0 to N-1.
        */
	FtRealComp = 0;
	FtImgComp = 0;
	for(num = 0;num < N;num++)
	{
		RealComp = cos (Theta * num);
		ImgComp = sin (Theta * num);
		FtRealComp = FtRealComp + RealComp * Signal[num];
		FtImgComp = FtImgComp - ImgComp *  Signal[num];
	}
       /*
       Output the calculated value.
       */
	printf("\nThe Fourier Transform of the signal at f = %f is,\n"
	       "Real Component = %f\n"
	       "Imaginary Component = %f",freq,FtRealComp,FtImgComp);
	getch();
	clrscr();
}

/*
This function is used to read the samples of the signal from the console.
Refer to Convolve.c  for explaination.
*/
void ReadSig()
{
	clrscr();
        for(j = 0;j < 80;j++)
		printf("");
        printf("\t\t\t\t Difference Equation Based Array Mapping.\n");
        for(j = 0;j < 80;j++)
		printf("");
	printf("Input The length of the signal: ");
	scanf("%d",&Xlen);
	clrscr();
        for(j = 0;j < 80;j++)
		printf("");
	printf("\t Difference Eqation Based Array Mapping. \n");
        for(j = 0;j < 80;j++)
		printf("");
	fflush(stdin);
	printf("Input the signal Samples: \n");
	for(i=0; i< Xlen; i++)
	{
		scanf("%f",&Signal[i]);
	}
        clrscr();
}

/*
This function is used to read the samples of the signal from the file.
Refer to Convolve.c  for explaination.
*/
void ReadFileSig()
{
  int SampleCount;
  int YsampleNo, Yinputs;
  char CompareTag[20],Xtag[20],Ytag[20];
  FILE *input;

	input = fopen(flnames,"r");
        if(input == NULL)
	{
		printf("Can't open file: %s \n",flnames);
		exit(1);
	}
        fscanf(input,"%s",CompareTag);
	if(strlen(CompareTag) != 12 || strcmp(CompareTag,FileTag) != 0)
	{
		printf("Invalid Tag in file: %s \n",flnames);
                exit(2);
	}
        if(feof(input))
	{
		printf("Invalid File Format. \n");
		exit(3);
	}
        fscanf(input,"%d",&Yinputs);
        if(feof(input) || Yinputs != 1)
	{
                if(Yinputs != 1)
                        printf("Can't take two inputs from single file.\n");
                else
                        printf("Invalid File Format. \n");
		exit(4);
	}
        fscanf(input,"%d",&YsampleNo);
        if(feof(input) || YsampleNo < 1)
	{
		printf("Invalid File Format. \n");
		exit(5);
	}
	if(YsampleNo > 500)
		YsampleNo = 500;

        fscanf(input,"%f",&MaxY);
        if(feof(input) || MaxY > 1.0e+5)
	{
		printf("Invalid File Format. \n");
		exit(5);
	}
        fscanf(input,"%f",&MinY);
        if(feof(input) || MinY < -1.0e5)
	{
		printf("Invalid File Format. \n");
		exit(6);
	}
        fscanf(input,"%s",Xtag);
        if(feof(input))
	{
		printf("Invalid File Format. \n");
		exit(7);
	}
        fscanf(input,"%s",Ytag);
        if(feof(input))
	{
		printf("Invalid File Format. \n");
		exit(8);
	}
	SampleCount = 0;
        while(!feof(input))
	{
             if(feof(input))
		break;
	     fscanf(input,"%f",&Signal[SampleCount]);

	     SampleCount++;
	     if(SampleCount > 499)
		break;
	}
	if(SampleCount < YsampleNo - 1)
	{
           printf("Invalid File Format. \n");
	   exit(9);
	}
	Xlen = SampleCount;
        rewind(input);
        fclose(input);

}
