/*
About this program:
This program is used to generate samples of 6 types of signals namely,
Sine, Cosine, Square, Random, Exponential, and Sawtooth.
The samples are generated using the mathematical expressions for the above
signals.
The Program takes in Type of the signal as input. It then asks for
parameters such as sampling frequency, frquency of the signal etc.
After taking these inputs it generates 500 samples of the signal
and stores them in a fil, name of which is input by the user.
The file can be viewed by using the utility program SHOW.
To get good results normally sa,pling frequency sholud be at least 8
times frequency of the signal.
*/
#include<stdio.h>
#include<conio.h>
#include<stdlib.h>
#include<ctype.h>
#include<math.h>
/*
FileTag is the specific string used to identify the file generated
using this program.
*/
#define FileTag "NGPFile&"
main()
{

  int i,j,SampleCount,Count,flag,choice,RandomNum;
  int YsampleNo, Yinputs;
  float yval,MaxY,MinY,Pi,Value,Difference,Tempval;
  float freq,Sampfreq,Nyquist,Amplitude;
  char Xtag[10],Ytag[10],YesNo,Filename[30];
  FILE *output;

	clrscr();
        /*
        Value of Pi is calculated here.
        */

        Pi = 22.0/7.0;

        /*Leave----------------------------------*/
	for(j = 0;j < 80;j++)
		printf("");
	printf("\t\t\t\t Sample Generator.\n");
	for(j = 0;j < 80;j++)
		printf("");
        /*--------------------------------------*/

        /*
        Take the choice of the waveform from the user.
        */
        printf("\nInput Your Choice:"
	       "\n 1. Sine."
	       "\n 2. Cosine."
	       "\n 3. Square."
	       "\n 4. Sawtooth."
	       "\n 5. Exponential."
	       "\n 6. Random."
	       "\n\n CHOICE: ");
	scanf("%d",&choice);

        /*
        If choice given is wrong exit from the program.
        */
        if(choice < 1 || choice > 6)
	{
		printf("\nInvalid Chioce !!\nExiting...");
		exit(0);
	}

        /*Leave----------------------------------*/        
	clrscr();
        for(j = 0;j < 80;j++)
		printf("");
        /*---------------------------------------*/

        /*
        Switch case statement is used to take various input parameters
        according to the type of the waveform.
        */
	switch (choice)
	{

		case 1:
			printf("**** Sine Wave Generation.");
                        /*
                        Get the frequency of the waveform.
                        */
			printf("\n\nInput the frequency: ");
			scanf("%f",&freq);

                        /*
                        Get the Sampling frequency.
                        */
                        
			printf("Input the Sampling frequency: ");
			scanf("%f",&Sampfreq);
                        /*
                        Calulation for Nyquist criterian.
                        */
			Nyquist = Sampfreq / freq;

                        /*
                        If Nyquist criterian is not satisfied exit from the
                        program.
                        */
			if(Nyquist < 2.0)
			{
				printf("\n**** ERROR ****"
				"\nAccording to the Nyquist Criterian"
				" Sampling frequency should be at least \n"
				"twice the waveform frequency.\n");
                                for(j = 0;j < 80;j++)
					printf("");
				printf("\nExiting...");
				exit(1);
			}
                        /*
                        We are generating only 500 samples, Warn the user
                        if the no. of samples per cycle exceed 500.
                        No. of samples per cycle =
                                                Sampling frequency
                                                -------------------
                                                Frequency of signal
                        */
			if(Nyquist > 500)
			{
				printf("\n**** Warning ****"
				"\n This will exceed the limit of 500 samples per cycle."
				"\n Are you Sure ? (y/n): ");
				fflush(stdin);
				YesNo = tolower(getche());
				printf("\n");
				if(YesNo != 'y')
				{
					for(j = 0;j < 80;j++)
						printf("");
					printf("\nExiting...");
					exit(1);
				}
			}
                        /*
                        Get the amplitude of the Waveform.
                        If it exceeds the limit exit the program.
                        */
			printf("\nInput the P-P amplitude of the Wave (<10000): ");
			scanf("%f",&Amplitude);
			if(Amplitude > 10000)
			{
					printf("\n**** Error ****"
					"\nAmplitude shouldn't exceed 10000.\n");
					for(j = 0;j < 80;j++)
						printf("");
					printf("\nExiting...");
					exit(1);
			}
                        /*
                        Calulate the maximum and minimum amplitudes of the
                        program.
                        In case of sine wave it is Vpp/2.
                        Vpp is specified as Amplitude.
                        */

			MaxY = Amplitude / 2.0;
			MinY = MaxY * (-1);

			fflush(stdin);
                        /*
                        Lable to be given to X axis.
                        */
			printf("\nInput the X axis label: ");
			scanf("%s",Xtag);
                        fflush(stdin);
                        /*
                        Lable to be given to Y axis.
                        */
			printf("Input the Y axis label: ");
			scanf("%s",Ytag);
                        fflush(stdin);
                        /*
                        Get the name of the file to be created.
                        */
			printf("\nInput FileName: ");
			scanf("%s",Filename);
			break;

		case 2:
                        /*
                        The parameters required for Cosine wave generation are same
                        as that for Sine wave generation, hence the code is repeated.
                        */
                        printf("**** Cosine Wave Generation.");
			printf("\n\nInput the frequency: ");
			scanf("%f",&freq);
			printf("Input the Sampling frequency: ");
			scanf("%f",&Sampfreq);
			Nyquist = Sampfreq / freq;

			if(Nyquist < 2.0)
			{
				printf("\n**** ERROR ****"
				"\nAccording to the Nyquist Criterian"
				" Sampling frequency should be at least \n"
				"twice the waveform frequency.\n");
                                for(j = 0;j < 80;j++)
					printf("");
				printf("\nExiting...");
				exit(1);
			}
			if(Nyquist > 500)
			{
				printf("\n**** Warning ****"
				"\n This will exceed the limit of 500 samples per cycle."
				"\n Are you Sure ? (y/n): ");
				fflush(stdin);
				YesNo = tolower(getche());
				printf("\n");
				if(YesNo != 'y')
				{
					for(j = 0;j < 80;j++)
						printf("");
					printf("\nExiting...");
					exit(1);
				}
			}
			printf("\nInput the P-P amplitude of the Wave (<10000): ");
			scanf("%f",&Amplitude);
			if(Amplitude > 10000)
			{
					printf("\n**** Error ****"
					"\nAmplitude shouldn't exceed 10000.\n");
					for(j = 0;j < 80;j++)
						printf("");
					printf("\nExiting...");
					exit(1);
			}
			MaxY = Amplitude / 2.0;
			MinY = MaxY * (-1);
			fflush(stdin);
			printf("\nInput the X axis label: ");
			scanf("%s",Xtag);
                        fflush(stdin);
			printf("Input the Y axis label: ");
			scanf("%s",Ytag);
                        fflush(stdin);
			printf("\nInput FileName: ");
			scanf("%s",Filename);
			break;

		case 3:
                        /*
                        The parameters required for Square wave generation are same
                        as that for Sine wave generation, hence the code is repeated.
                        */

                        printf("**** Square Wave Generation.");
			printf("\n\nInput the frequency: ");
			scanf("%f",&freq);
			printf("Input the Sampling frequency: ");
			scanf("%f",&Sampfreq);
			Nyquist = Sampfreq / freq;

			if(Nyquist < 2.0)
			{
				printf("\n**** ERROR ****"
				"\nAccording to the Nyquist Criterian"
				" Sampling frequency should be at least \n"
				"twice the waveform frequency.\n");
                                for(j = 0;j < 80;j++)
					printf("");
				printf("\nExiting...");
				exit(1);
			}
			if(Nyquist > 500)
			{
				printf("\n**** Warning ****"
				"\n This will exceed the limit of 500 samples per cycle."
				"\n Are you Sure ? (y/n): ");
				fflush(stdin);
				YesNo = tolower(getche());
				printf("\n");
				if(YesNo != 'y')
				{
					for(j = 0;j < 80;j++)
						printf("");
					printf("\nExiting...");
					exit(1);
				}
			}
			printf("\nInput the P-P amplitude of the Wave (<10000): ");
			scanf("%f",&Amplitude);
			if(Amplitude > 10000)
			{
					printf("\n**** Error ****"
					"\nAmplitude shouldn't exceed 10000.\n");
					for(j = 0;j < 80;j++)
						printf("");
					printf("\nExiting...");
					exit(1);
			}
			MaxY = Amplitude / 2.0;
			MinY = MaxY * (-1);
			fflush(stdin);
			printf("\nInput the X axis label: ");
			scanf("%s",Xtag);
                        fflush(stdin);
			printf("\nInput the Y axis label: ");
			scanf("%s",Ytag);
                        fflush(stdin);
			printf("\nInput FileName: ");
			scanf("%s",Filename);
			break;
		case 4:
                        /*
                        The parameters required for Sawtooth wave generation are same
                        as that for Sine wave generation, hence the code is repeated.
                        */

                        printf("**** Sawtooth Generation.");
			printf("\n\nInput the frequency: ");
			scanf("%f",&freq);
			printf("Input the Sampling frequency: ");
			scanf("%f",&Sampfreq);
			Nyquist = Sampfreq / freq;

			if(Nyquist < 2.0)
			{
				printf("\n**** ERROR ****"
				"\nAccording to the Nyquist Criterian"
				" Sampling frequency should be at least \n"
				"twice the waveform frequency.\n");
                                for(j = 0;j < 80;j++)
					printf("");
				printf("\nExiting...");
				exit(1);
			}
			if(Nyquist > 500)
			{
				printf("\n**** Warning ****"
				"\n This will exceed the limit of 500 samples per cycle."
				"\n Are you Sure ? (y/n): ");
				fflush(stdin);
				YesNo = tolower(getche());
				printf("\n");
				if(YesNo != 'y')
				{
					for(j = 0;j < 80;j++)
						printf("");
					printf("\nExiting...");
					exit(1);
				}
			}
			printf("\nInput the P-P amplitude of the Wave (<10000): ");
			scanf("%f",&Amplitude);
			if(Amplitude > 10000)
			{
					printf("\n**** Error ****"
					"\nAmplitude shouldn't exceed 10000.\n");
					for(j = 0;j < 80;j++)
						printf("");
					printf("\nExiting...");
					exit(1);
			}
			MaxY = Amplitude / 2.0;
			MinY = MaxY * (-1);
			fflush(stdin);
			printf("\nInput the X axis label: ");
			scanf("%s",Xtag);
                        fflush(stdin);
			printf("\nInput the Y axis label: ");
			scanf("%s",Ytag);
                        fflush(stdin);
			printf("\nInput FileName: ");
			scanf("%s",Filename);
			break;
		case 5:
                        /*
                        In case of exponetial waveform the peak amplitude is
                        calulated using the interval input by the user.
                        The samples are generated by taking exponential at
                        this interval.
                        */
                        printf("**** Exponential Generation.");
                        printf("\n\nInput the Interval in sec(< 0.1): ");
			scanf("%f",&Difference);
                        if(Difference > 0.100000000000001) /* ~ 0.1*/
			{
				printf("\n**** ERROR ****"
				"\n Sampling Interval should be less than"
				" 0.1 Sec.\n");
                                for(j = 0;j < 80;j++)
					printf("");
				printf("\nExiting...");
				exit(1);
			}
			MaxY = exp(Difference * 500);
			if(MaxY > 1.0e10)
			{
				printf("\n**** Warning ****"
				"\n This will saturate the samples."
				"\n Are you Sure ? (y/n): ");
				fflush(stdin);
				YesNo = tolower(getche());
				printf("\n");
				if(YesNo != 'y')
				{
					for(j = 0;j < 80;j++)
						printf("");
					printf("\nExiting...");
					exit(1);
				}
				MaxY = 1.0e10;
			}
			MinY = 0;
			fflush(stdin);
			printf("\nInput the X axis label: ");
			scanf("%s",Xtag);
                        fflush(stdin);
			printf("\nInput the Y axis label: ");
			scanf("%s",Ytag);
                        fflush(stdin);
			printf("\nInput FileName: ");
			scanf("%s",Filename);
			break;
		case 6:
                        /*
                        In case of random signal the parameters frequency and
                        sampling frquency are of little importance to us since
                        random signal will contain therotically all frequencies
                        zero to sampling frequency / 2.
                        */

                        printf("**** Random Signal Generation.");
			printf("\n\nInput the frequency: ");
			scanf("%f",&freq);
			printf("Input the Sampling frequency: ");
			scanf("%f",&Sampfreq);
			Nyquist = Sampfreq / freq;

			if(Nyquist < 2.0)
			{
				printf("\n**** ERROR ****"
				"\nAccording to the Nyquist Criterian"
				" Sampling frequency should be at least \n"
				"twice the waveform frequency.\n");
                                for(j = 0;j < 80;j++)
					printf("");
				printf("\nExiting...");
				exit(1);
			}
			if(Nyquist > 500)
			{
				printf("\n**** Warning ****"
				"\n This will exceed the limit of 500 samples per cycle."
				"\n Are you Sure ? (y/n): ");
				fflush(stdin);
				YesNo = tolower(getche());
				printf("\n");
				if(YesNo != 'y')
				{
					for(j = 0;j < 80;j++)
						printf("");
					printf("\nExiting...");
					exit(1);
				}
			}
			printf("\nInput the P-P amplitude of the Wave (<10000): ");
			scanf("%f",&Amplitude);
			if(Amplitude > 10000)
			{
					printf("\n**** Error ****"
					"\nAmplitude shouldn't exceed 10000.\n");
					for(j = 0;j < 80;j++)
						printf("");
					printf("\nExiting...");
					exit(1);
			}
			MaxY = Amplitude;
			MinY = 0;
			fflush(stdin);
			printf("\nInput the X axis label: ");
			scanf("%s",Xtag);
                        fflush(stdin);
			printf("Input the Y axis label: ");
			scanf("%s",Ytag);
                        fflush(stdin);
			printf("\nInput FileName: ");
			scanf("%s",Filename);
			break;

	}
        /*
        Open the file for writing.
        */
	output = fopen(Filename,"w");
	if(output == NULL)
	{
		printf("Can't open file: %s \n",Filename);
		exit(3);
	}
        /*
        Write the FileTag, No of signals, distance bet. X axis pixels,
        No of samples, Maximum and minimum amplitude, X axis tag and
        Y axis Tag.
        */
	fprintf(output,FileTag);
	fprintf(output,"\n1");
	fprintf(output,"\n1");
	fprintf(output,"\n500");
	fprintf(output,"\n%f",MaxY);
	fprintf(output,"\n%f",MinY);
	fprintf(output,"\n%s",Xtag);
	fprintf(output,"\n%s",Ytag);

        /*
        Generate the samples accoring to the type of the waveform.
        */
        switch(choice)
        {
                case 1:
                        for(j = 0;j < 80;j++)
				printf("");
			printf("Generating samples...");

                        /*
                        Sampling point.
                        */
			Value = 0;

                        /*
                        Sampling interval.
                        */
                        Difference = freq/Sampfreq;

                        /*
                        Generate 500 samples.
                        */
                        for(i= 0;i< 500;i++)
                        {
                              Tempval = Value * 2 * Pi;
                              /*
                              Expression for Sine.
                              */
                              yval = sin(Tempval) * MaxY;
                              fprintf(output,"\n%f",yval);
                              Value = Value + Difference;
			}
			printf("\nOK.\n\n\nPress Any key to exit.");
			getch();
			break;
		case 2:
                        /*
                        Same as sine only the expression changes.
                        */
                        for(j = 0;j < 80;j++)
				printf("");
			printf("Generating samples...");
			Value = 0;
                        Difference = freq/Sampfreq;
                        for(i= 0;i< 500;i++)
                        {
                              Tempval = Value * 2 * Pi;
                              /*
                              Expression for Cosine.
                              */

			      yval = cos(Tempval) * MaxY;
                              fprintf(output,"\n%f",yval);
                              Value = Value + Difference;
			}
			printf("\nOK.\n\n\nPress Any key to exit.");
			getch();
			break;
		case 3:
                        for(j = 0;j < 80;j++)
				printf("");
			printf("Generating samples...");
                        Count = 0;
                        flag = 0;
                        /*
                        Calculate the interval.
                        */
			Difference = freq/Sampfreq;
                        for(i= 0;i< 500;i++,Count++)
                        {
                                Tempval = 1/(Difference * 2);
                                /*
                                Sample count will be half the no of samples per
                                cycle.
                                In case of square wave the amplitude is 1 for half
                                the samples and -1 for remaining samples.
                                */
                                SampleCount =  (int) Tempval;
                                if(flag == 0)
					yval = MaxY;
                                else
					yval = MinY;
                                if(Count >= SampleCount)
                                {
                                        if(flag == 0)
                                                flag = 1;
                                         else
                                                flag = 0;
                                         Count = 0;
                                }
                                fprintf(output,"\n%f",yval);
			}
			printf("\nOK.\n\n\nPress Any key to exit.");
			getch();
			break;
		case 4:
                        for(j = 0;j < 80;j++)
				printf("");
			printf("Generating samples...");
                        Count = 0;
			Difference = freq/Sampfreq;
			yval = MinY;
                        for(i= 0;i< 500;i++,Count++)
                        {
				Tempval = 1/Difference;
				SampleCount =  (int) Tempval;
                                /*
                                Increment the amplitude of the wave linealy
                                with the number samples in the cycle.
                                */
				yval = yval + (MaxY - MinY)/ Tempval;
				if(Count >= SampleCount)
				{
                                        /*
                                        At the end of one cycle make amplitude
                                        minimum again.
                                        */
                                        Count = 0;
					yval = MinY;
                                }
                                fprintf(output,"\n%f",yval);
			}
			printf("\nOK.\n\n\nPress Any key to exit.");
			getch();
			break;
		case 5:
                        for(j = 0;j < 80;j++)
				printf("");
			printf("Generating samples...");
			Count = 0;
			Tempval = 0;
                        for(i= 0;i< 500;i++,Count++)
                        {
                                /*
                                Calculate exponential value at the
                                current time intant.
                                */
                                yval = exp(Tempval);
                                /*
                                Saturate the samples if Amplitude exceeds
                                specified limit.
                                */
				if(yval >=  1.0e10)
				{
				    yval = 1.0e10;
				}
				fprintf(output,"\n%f",yval);

                                /*
                                Increament the value of time instant by
                                time interval.
                                */
                                Tempval = Tempval + Difference;
			}
			printf("\nOK.\n\n\nPress Any key to exit.");
			getch();
			break;
		case 6:
                        /*
                        Random function is generated using random
                        number generator and then rescaling it.
                        */
                        for(j = 0;j < 80;j++)
				printf("");
			printf("Generating samples...");
                        for(i= 0;i< 500;i++)
			{     RandomNum = random(1000);
			      yval = (RandomNum*MaxY)/1000;
                              fprintf(output,"\n%f",yval);
			}
			printf("\nOK.\n\n\nPress Any key to exit.");
			getch();
			break;
        }
        /*
        Close the file.
        */
	fclose(output);

}
